//+------------------------------------------------------------------+
//|                                                  Custom MACD.mq4 |
//|                      Copyright ? 2004, MetaQuotes Software Corp. |
//|                                      |
//+------------------------------------------------------------------+
#property  copyright "Copyright ? 2004, MetaQuotes Software Corp."
#property  link      "http://www.metaquotes.net/"
//---- indicator settings
#property  indicator_chart_window
#property  indicator_buffers 1
#property  indicator_color1  Silver

#property  indicator_width1  1

//---- indicator parameters
extern int    timeFrame = 0;
extern double FastEMA   = 12;
extern double SlowEMA   = 26;
extern double SignalEMA = 9;
extern bool   ShowObjects = true;
//---- indicator buffers

double Price[];
double predict[];



//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- drawing settings
   
   SetIndexStyle(0,DRAW_LINE,STYLE_DOT);
   SetIndexDrawBegin(0,FastEMA);

//---- indicator buffers mapping
   SetIndexBuffer(0,Price);
 
//---- name for DataWindow and indicator subwindow label
   IndicatorShortName("MACD("+FastEMA+","+SlowEMA+","+SignalEMA+")");
   SetIndexLabel(0,"MACD Predictor");

//---- initialization done
   return(0);
  }
int deinit()
{
   ObjectDelete("signal1");
   
return(0);
}
//+------------------------------------------------------------------+
//| Moving Averages Convergence/Divergence                           |
//+------------------------------------------------------------------+
int start()
  {
   double v1minus2divsgEMAplus1 = 1.0 - 2.0 / (SignalEMA + 1.0);
   double v1minus2divSEMAplus1  = 1.0 - 2.0 / (SlowEMA + 1.0);
   double v1minus2divFEMAplus1  = 1.0 - 2.0 / (FastEMA + 1.0);
   double FEMAmSEMAt2           = 2 * (FastEMA - SlowEMA);
   double FEMAp1tSEMAp1         = (FastEMA + 1.0)*(SlowEMA + 1.0);
   
   int counted_bars=IndicatorCounted();
   int pos,limit;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit=MathMax(Bars-counted_bars,3*timeFrame/Period());
   
   //
   //
   //
   //
   //
   
   
   
      
      
      for (int i=limit;i>=0;i--)
      {
         int y = iBarShift(NULL,timeFrame,Time[i]);
         double predict  =(-1.0) / (FEMAmSEMAt2 * v1minus2divsgEMAplus1) * FEMAp1tSEMAp1 * ((-v1minus2divsgEMAplus1)*(iMA(NULL,0,        FastEMA,0,1,PRICE_CLOSE,0)   * v1minus2divFEMAplus1 - iMA(NULL,0,        SlowEMA,0,1,PRICE_CLOSE,0)   * v1minus2divSEMAplus1 ));// + iCustom(NULL,0,"DiNapoli MACD",FastEMA,SlowEMA,SignalEMA,false,0,0) * v1minus2divsgEMAplus1);
                Price[i] =(-1.0) / (FEMAmSEMAt2 * v1minus2divsgEMAplus1) * FEMAp1tSEMAp1 * ((-v1minus2divsgEMAplus1)*(iMA(NULL,timeFrame,FastEMA,0,1,PRICE_CLOSE,y+1) * v1minus2divFEMAplus1 - iMA(NULL,timeFrame,SlowEMA,0,1,PRICE_CLOSE,y+1) * v1minus2divSEMAplus1 ));// + iCustom(NULL,0,"DiNapoli MACD",FastEMA,SlowEMA,SignalEMA,false,0,i+1) * v1minus2divsgEMAplus1);
      //double predict=(-1.0)*1.0/((FastEMA-SlowEMA)*2*(1.0-2.0/(SignalEMA+1.0)))* (FastEMA+1.0)*(SlowEMA+1.0)*((2.0/(SignalEMA+1.0)-1.0)*(iMA(NULL,0,FastEMA,0,1,PRICE_CLOSE,0)*(1.0-2.0/(FastEMA+1.0))-iMA(NULL,0,SlowEMA,0,1,PRICE_CLOSE,0)*(1.0-2.0/(SlowEMA+1.0)))+iCustom(NULL,0,"DiNapoli MACD",FastEMA,SlowEMA,SignalEMA,false,0,0)*(1-2.0/(SignalEMA+1.0)));

    datetime futureBarTime  = Time[i]+timeFrame*60;  
    datetime futureBarTime1 = Time[i];  
 
      if (ShowObjects)
      {
         ObjectCreate("signal1",OBJ_TREND,0,Time[i],Price[i],futureBarTime,predict);
            ObjectSet("signal1",OBJPROP_COLOR,Gold);
            ObjectSet("signal1",OBJPROP_RAY,false);
            ObjectSet("signal1",OBJPROP_STYLE,STYLE_DASH);
            double predict1=ObjectGet("signal1",OBJPROP_PRICE1);
                     
      
          if(predict1<predict||predict1>predict)
          {
            ObjectDelete("signal1");
            ObjectCreate("signal1",OBJ_TREND,0,Time[i],Price[i],futureBarTime,predict);
               ObjectSet("signal1",OBJPROP_COLOR,Gold);
               ObjectSet("signal1",OBJPROP_RAY,false);
               ObjectSet("signal1",OBJPROP_STYLE,STYLE_DASH);
               predict1=ObjectGet("signal1",OBJPROP_PRICE1);
          }
      }  
   }
   return(0);
   
  }
//+------------------------------------------------------------------+